Index: trunk/MagicSoft/Mars/mcamera/CameraLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mcamera/CameraLinkDef.h	(revision 3985)
+++ trunk/MagicSoft/Mars/mcamera/CameraLinkDef.h	(revision 6963)
@@ -12,4 +12,6 @@
 #pragma link C++ class MCameraLV+;
 #pragma link C++ class MCameraDC+;
+#pragma link C++ class MCameraActiveLoad+;
+#pragma link C++ class MCameraCentralPix+;
 #pragma link C++ class MCameraCalibration+;
 #pragma link C++ class MCameraPowerSupply+;
Index: trunk/MagicSoft/Mars/mcamera/MCameraActiveLoad.cc
===================================================================
--- trunk/MagicSoft/Mars/mcamera/MCameraActiveLoad.cc	(revision 6963)
+++ trunk/MagicSoft/Mars/mcamera/MCameraActiveLoad.cc	(revision 6963)
@@ -0,0 +1,34 @@
+/* ======================================================================== *\
+!
+! *
+! * This file is part of MARS, the MAGIC Analysis and Reconstruction
+! * Software. It is distributed to you in the hope that it can be a useful
+! * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
+! * It is distributed WITHOUT ANY WARRANTY.
+! *
+! * Permission to use, copy, modify and distribute this software and its
+! * documentation for any purpose is hereby granted without fee,
+! * provided that the above copyright notice appear in all copies and
+! * that both that copyright notice and this permission notice appear
+! * in supporting documentation. It is provided "as is" without express
+! * or implied warranty.
+! *
+!
+!
+!   Author(s): Daniel Mazin, 04/2005 <mailto:mazin@mppmu.mpg.de>
+!
+!   Copyright: MAGIC Software Development, 2000-2005
+!
+!
+\* ======================================================================== */
+
+/////////////////////////////////////////////////////////////////////////////
+//
+// MCameraActiveLoad
+//
+/////////////////////////////////////////////////////////////////////////////
+#include "MCameraActiveLoad.h"
+
+ClassImp(MCameraActiveLoad);
+
+using namespace std;
Index: trunk/MagicSoft/Mars/mcamera/MCameraActiveLoad.h
===================================================================
--- trunk/MagicSoft/Mars/mcamera/MCameraActiveLoad.h	(revision 6963)
+++ trunk/MagicSoft/Mars/mcamera/MCameraActiveLoad.h	(revision 6963)
@@ -0,0 +1,45 @@
+#ifndef MARS_MCameraActiveLoad
+#define MARS_MCameraActiveLoad
+
+#ifndef MARS_MParContainer
+#include "MParContainer.h"
+#endif
+
+class MCameraActiveLoad : public MParContainer
+{
+    friend class MReportCamera;
+
+private:
+    Bool_t fStatus;               // Status of active loads (0xff means: n/a)
+
+    Float_t fVoltage360A;         // [V] Voltage of 360V power supply A
+    Float_t fIntens360A;          // [mA] Intensity of 360V power supply A
+    Float_t fVoltage360B;         // [V] Voltage of 360V power supply B
+    Float_t fIntens360B;          // [mA] Intensity of 360V power supply B
+    Float_t fVoltage175A;         // [V] Voltage of 175V power supply A
+    Float_t fIntens175A;          // [mA] Intensity of 175V power supply A
+    Float_t fVoltage175B;         // [V] Voltage of 175V power supply B
+    Float_t fIntens175B;          // [mA] Intensity of 175V power supply B
+
+public:
+    MCameraActiveLoad()
+    {
+        fName  = "MCameraActiveLoad";
+        fTitle = "Container storing information about the Camera Active Load system";
+    }
+
+    Bool_t  GetStatus() const      { return fStatus;      }
+
+    Float_t GetVoltage360A() const { return fVoltage360A; }
+    Float_t GetIntens360A() const  { return fIntens360A;  }
+    Float_t GetVoltage360B() const { return fVoltage360B; }
+    Float_t GetIntens360B() const  { return fIntens360B;  }
+    Float_t GetVoltage175A() const { return fVoltage175A; }
+    Float_t GetIntens175A() const  { return fIntens175A;  }
+    Float_t GetVoltage175B() const { return fVoltage175B; }
+    Float_t GetIntens175B() const  { return fIntens175B;  }
+
+    ClassDef(MCameraActiveLoad, 1) // Container storing information about the Active Loads of the Camera
+};
+
+#endif
Index: trunk/MagicSoft/Mars/mcamera/MCameraCentralPix.cc
===================================================================
--- trunk/MagicSoft/Mars/mcamera/MCameraCentralPix.cc	(revision 6963)
+++ trunk/MagicSoft/Mars/mcamera/MCameraCentralPix.cc	(revision 6963)
@@ -0,0 +1,34 @@
+/* ======================================================================== *\
+!
+! *
+! * This file is part of MARS, the MAGIC Analysis and Reconstruction
+! * Software. It is distributed to you in the hope that it can be a useful
+! * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
+! * It is distributed WITHOUT ANY WARRANTY.
+! *
+! * Permission to use, copy, modify and distribute this software and its
+! * documentation for any purpose is hereby granted without fee,
+! * provided that the above copyright notice appear in all copies and
+! * that both that copyright notice and this permission notice appear
+! * in supporting documentation. It is provided "as is" without express
+! * or implied warranty.
+! *
+!
+!
+!   Author(s): Daniel Mazin, 04/2005 <mailto:mazin@mppmu.mpg.de>
+!
+!   Copyright: MAGIC Software Development, 2000-2005
+!
+!
+\* ======================================================================== */
+
+/////////////////////////////////////////////////////////////////////////////
+//
+// MCameraCentralPix
+//
+/////////////////////////////////////////////////////////////////////////////
+#include "MCameraCentralPix.h"
+
+ClassImp(MCameraCentralPix);
+
+using namespace std;
Index: trunk/MagicSoft/Mars/mcamera/MCameraCentralPix.h
===================================================================
--- trunk/MagicSoft/Mars/mcamera/MCameraCentralPix.h	(revision 6963)
+++ trunk/MagicSoft/Mars/mcamera/MCameraCentralPix.h	(revision 6963)
@@ -0,0 +1,28 @@
+#ifndef MARS_MCameraCentralPix
+#define MARS_MCameraCentralPix
+
+#ifndef MARS_MParContainer
+#include "MParContainer.h"
+#endif
+
+class MCameraCentralPix : public MParContainer
+{
+    friend class MReportCamera;
+
+private:
+    Bool_t fStatus; // Status of central pixel
+
+public:
+    MCameraCentralPix()
+    {
+        fName  = "MCameraCentralPix";
+        fTitle = "Container storing information about the Camera Central Pixel";
+    }
+
+    Bool_t GetStatus() const     { return fStatus; }
+    Bool_t GetStatusCPix() const { return fStatus; } // deprecated - for compatibility only
+
+    ClassDef(MCameraCentralPix, 1) // Container storing information about the Central Pixel status
+};
+
+#endif
Index: trunk/MagicSoft/Mars/mcamera/Makefile
===================================================================
--- trunk/MagicSoft/Mars/mcamera/Makefile	(revision 3985)
+++ trunk/MagicSoft/Mars/mcamera/Makefile	(revision 6963)
@@ -30,4 +30,6 @@
 	   MCameraLid.cc \
 	   MCameraLids.cc \
+	   MCameraActiveLoad.cc \
+	   MCameraCentralPix.cc \
 	   MCameraPowerSupply.cc
 